Citizen.CreateThread(function()
    local playerPed = PlayerPedId() 
    while true do
        Citizen.Wait(100) 
        if DoesEntityExist(playerPed) and not IsEntityDead(playerPed) then
            SetEntityCollision(playerPed, true, true)

            local playerCoords = GetEntityCoords(playerPed)
            local npc = GetClosestPed(playerCoords.x, playerCoords.y, playerCoords.z, 50.0, true, false, false, false, 26)

            if npc and DoesEntityExist(npc) and not IsPedAPlayer(npc) then
                local npcCoords = GetEntityCoords(npc)
                local distance = #(playerCoords - npcCoords)

                if distance < 20.0 then
                    TaskGoToCoordAnyMeans(npc, playerCoords.x, playerCoords.y, playerCoords.z, 2.0, 0, 0, 786603, 0)
                    SetPedKeepTask(npc, true)
                end
            end
        end
    end
end)

function GetClosestPed(x, y, z, radius, p1, p2, p7, p8, pedType)
    local handle, ped = FindFirstPed()
    local success
    local rPed = nil
    local distance = radius

    repeat
        local pedCoords = GetEntityCoords(ped)
        local pedDistance = #(vector3(x, y, z) - pedCoords)

        if pedDistance < distance and not IsPedAPlayer(ped) then
            distance = pedDistance
            rPed = ped
        end

        success, ped = FindNextPed(handle)
    until not success

    EndFindPed(handle)
    return rPed
end
