RegisterNetEvent("checkping:list")
AddEventHandler("checkping:list", function(playerList)
    TriggerEvent("chat:addMessage", {
        args = { "List of All Players' Pings:" }
    })

    local totalPing = 0
    local highestPing = 0
    local highestPingPlayer = ""
    local playerCount = #playerList

    -- Proses setiap pemain
    for _, player in ipairs(playerList) do
        TriggerEvent("chat:addMessage", {
            args = { player }
        })

        local name, ping = string.match(player, "(.-): (%d+)")
        ping = tonumber(ping)

        if ping then
            totalPing = totalPing + ping

            if ping > highestPing then
                highestPing = ping
                highestPingPlayer = name
            end
        end
    end

    local averagePing = totalPing / playerCount
    local analysisMessage = string.format(
        "Analysis: Average Ping: %.2f ms | Highest Ping: %d ms (Player: %s)",
        averagePing, highestPing, highestPingPlayer
    )

    -- Menampilkan analisis
    TriggerEvent("chat:addMessage", {
        args = { analysisMessage }
    })
    if averagePing > 100 then
        TriggerEvent("chat:addMessage", {
            args = { "Recommendation: The average ping is quite high. Consider optimizing server settings or advising players to check their network." }
        })
    end
end)
