Citizen.CreateThread(function()
    local lastUpdate = 0
    local lastPos = nil
    while true do
        Citizen.Wait(50)
        local currentTime = GetGameTimer()
        if currentTime - lastUpdate > 500 then
            local pos = GetEntityCoords(PlayerPedId())
            
            if lastPos then
                local predictedPos = vector3(
                    pos.x + (pos.x - lastPos.x),
                    pos.y + (pos.y - lastPos.y),
                    pos.z + (pos.z - lastPos.z)
                )
                TriggerServerEvent("syncPlayerPredictedPos", pos, predictedPos)
            else
                TriggerServerEvent("syncPlayerPredictedPos", pos, pos)
            end

            lastPos = pos
            lastUpdate = currentTime
        end
    end
end)

RegisterNetEvent("updateOtherPlayerPos")
AddEventHandler("updateOtherPlayerPos", function(playerId, newPos, predictedPos)
    local playerPed = GetPlayerPed(playerId)
    if DoesEntityExist(playerPed) then
        local posToSet = predictedPos or newPos
        SetEntityCoordsNoOffset(playerPed, posToSet.x, posToSet.y, posToSet.z, true, true, true)
    end
end)

RegisterNetEvent("syncPlayerPredictedPos")
AddEventHandler("syncPlayerPredictedPos", function(pos, predictedPos)
    print("The server accepts the position:", pos, "and prediction positions:", predictedPos)
end)
