local playerPingHistory = {}

Citizen.CreateThread(function()
    while true do
        Citizen.Wait(1000)
        
        -- Ambil semua pemain
        local players = GetPlayers()
        for _, playerId in ipairs(players) do
            local ping = GetPlayerPing(playerId)
            
            if not playerPingHistory[playerId] then
                playerPingHistory[playerId] = {ping}
            else
                table.insert(playerPingHistory[playerId], ping)
            end

            local recentPings = playerPingHistory[playerId]
            if #recentPings > 3 then
                local recentAveragePing = 0
                for i = #recentPings - 2, #recentPings do
                    recentAveragePing = recentAveragePing + recentPings[i]
                end
                recentAveragePing = recentAveragePing / 3

                if recentAveragePing > 200 then
                    local success, errorMessage = xpcall(function()
                        DropPlayer(playerId, "Your ping is consistently too high. Please try again later.")
                    end, function(err)
                        return "Error while kicking player: " .. err
                    end)

                    if not success then
                        print(errorMessage) 
                    end
                end
            end
        end

        collectgarbage("collect")
    end
end)
