RegisterCommand("checkping", function(source, args, rawCommand)
    local playerId = source
    local playerPing = GetPlayerPing(playerId)
    
    local pingStatus = "Normal"
    if playerPing < 50 then
        pingStatus = "Good"
    elseif playerPing >= 50 and playerPing < 150 then
        pingStatus = "Average"
    elseif playerPing >= 150 then
        pingStatus = "High - You may experience lag"
    end
    
    TriggerClientEvent("chat:addMessage", playerId, {
        args = { "Your Ping: ", playerPing, "Status: ", pingStatus }
    })

    local players = GetPlayers() 
    local playerList = {}

    for _, id in ipairs(players) do
        local ping = GetPlayerPing(id)
        local name = GetPlayerName(id)
        local otherPingStatus = "Normal"
        if ping < 50 then
            otherPingStatus = "Good"
        elseif ping >= 50 and ping < 150 then
            otherPingStatus = "Average"
        elseif ping >= 150 then
            otherPingStatus = "High"
        end
        
        table.insert(playerList, name .. " (" .. ping .. "ms - " .. otherPingStatus .. ")")
    end
    
    TriggerClientEvent("checkping:list", playerId, playerList)
end, false)
