RegisterNetEvent('performance:updateGraphicsSettings')
AddEventHandler('performance:updateGraphicsSettings', function(lodDistanceBias, pedLodBias, vehicleLodBias, particleLightMultiplier, skyQuality, pedDensity, vehicleDensity)

    local valid = true
    local graphicsSettings = {
        lodDistanceBias = lodDistanceBias,
        pedLodBias = pedLodBias,
        vehicleLodBias = vehicleLodBias,
        particleLightMultiplier = particleLightMultiplier,
        skyQuality = skyQuality,
        pedDensity = pedDensity,
        vehicleDensity = vehicleDensity
    }

    for setting, value in pairs(graphicsSettings) do
        if type(value) ~= 'number' or value < 0 or value > 100 then
            valid = false
            break
        end
    end

    if valid then
        local source = source
        TriggerClientEvent('performance:applyGraphicsSettings', source, graphicsSettings)
    else
        TriggerClientEvent('performance:showError', source, 'Invalid graphics settings received.')
    end
end)
